package com.loafle.commons.rpc.protocol.json;

import java.io.IOException;

import com.loafle.commons.rpc.RPCException;
import com.loafle.commons.rpc.protocol.RPCClientCodec;
import com.loafle.commons.rpc.protocol.RPCClientResponseCodec;

import org.codehaus.jackson.map.ObjectMapper;

/**
 * JSONRPCClientCodec
 */
public class JSONRPCClientCodec extends JSONRPCCodec implements RPCClientCodec {
  public JSONRPCClientCodec() {
  }

  public JSONRPCClientCodec(ObjectMapper objectMapper) {
    super(objectMapper);
  }

	@Override
	public byte[] request(String method, Object[] params, Object id) throws RPCException {
    JSONClientRequest request = new JSONClientRequest(JSONRPC.version, method, params, id);

    try {
      String json = this.objectMapper.writeValueAsString(request);
      return json.getBytes();
    } catch (IOException e) {
      throw new RPCException("cannot marsharling", e);
    }
	}

	@Override
	public RPCClientResponseCodec response(byte[] buf) throws RPCException {
		return new JSONRPCClientResponseCodec(this.objectMapper, buf);
	}
}